<template>
  <div>
    <!-- Desktop -->
    <div class="gt-md mainWidth">
      <div>
        <top-bar />
      </div>
      <div class="row content">
        <div class="leftMenu">
          <left-menu
            ref="leftMenu"
            :chapterData="chapterData"
            :bookData="bookData"
            @chapter="loadpage"
          />
        </div>
        <div class="col rightPanel">
          <main-panel
            :bookData="bookData"
            :catData="catData"
            :pageData="pageData"
            :perviousPage="previousPage"
            :nextPage="nextPage"
            @perviousChapter="perviousChapter"
            @nextChapter="nextChapter"
          />
        </div>
      </div>
    </div>
    <!-- mobile -->
    <div class="lt-sm">
      <top-bar />

      <main-panel-mobile
        :bookData="bookData"
        :catData="catData"
        :pageData="pageData"
        :chapterData="chapterData"
      />
    </div>
    <!-- tablet -->
    <div class="lt-lg gt-xs">
      <top-bar />
      <main-panel-mobile
        :bookData="bookData"
        :catData="catData"
        :pageData="pageData"
        :chapterData="chapterData"
      />
    </div>
  </div>
</template>

<script>
import axios from "axios";
import topBar from "../components/topbar.vue";
import leftMenu from "../components/chapter/leftmenu.vue";
import mainPanel from "../components/chapter/mainpanel.vue";
import mainPanelMobile from "../components/chapter/mainpanelmobile.vue";
import showAds from "../components/ads.vue";
export default {
  components: { topBar, leftMenu, mainPanel, mainPanelMobile, showAds },
  data() {
    return {
      bookID: "",
      chapterData: [],
      bookData: [],
      catData: [],
      pageData: [],
      currentPageId: 0,
      nextPage: true,
      previousPage: true,
    };
  },
  methods: {
    nextChapter() {
      let currentIndex = this.chapterData.findIndex(
        (x) => x.id == this.currentPageId
      );
      let setId = this.chapterData[currentIndex - 1].id;
      this.$refs.leftMenu.chapterSelected(setId);
    },
    perviousChapter() {
      let currentIndex = this.chapterData.findIndex(
        (x) => x.id == this.currentPageId
      );

      let setId = this.chapterData[currentIndex + 1].id;
      this.$refs.leftMenu.chapterSelected(setId);
    },
    async loadpage(id) {
      this.currentPageId = id;
      let currentIndex = this.chapterData.findIndex(
        (x) => x.id == this.currentPageId
      );
      this.nextPage = true;
      this.previousPage = true;
      if (currentIndex == 0) {
        this.nextPage = false;
        this.previousPage = true;
      }

      if (currentIndex == this.chapterData.length - 1) {
        this.nextPage = true;
        this.previousPage = false;
      }

      let pathfile = "cartoon/" + this.bookData[0].folder + "/" + id;
      let dataSend = {
        pathfile: pathfile,
      };

      let url = this.serverpath + "fe_filelist.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.pageData = res.data;
      // this.pageData.push('temp');
      // this.pageData.pop()
    },
    async loadChapterData() {
      let dataSend = {
        bookID: Number(this.bookID),
      };
      let url = this.serverpath + "fe_loadchapter.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      res.data.sort((a, b) => Number(a.orderid) - Number(b.orderid));
      this.chapterData = res.data;

      this.loadpage(this.chapterData[this.chapterData.length - 1].id);
    },
    async loadBookData() {
      let dataSend = {
        bookID: Number(this.bookID),
      };

      let url = this.serverpath + "fe_loadbook.php";
      let res = await axios.post(url, JSON.stringify(dataSend));
      this.bookData = res.data;
    },
    async loadCatData() {
      let url = this.serverpath + "fe_loadcat.php";
      let res = await axios.get(url);
      this.catData = res.data;
      // console.log(this.catData);
    },
  },
  async created() {
    this.bookID = this.$route.params.bookID;
    await this.loadCatData();
    await this.loadBookData();
    this.loadChapterData();
  },
};
</script>

<style lang="scss" scoped>
.leftMenu {
  width: 300px;
  border: 1px solid #d9d9d9;
  height: calc(100vh - 55px);
}
.rightPanel {
  border: 1px solid #d9d9d9;
  height: calc(100vh - 55px);
}
.content {
  position: relative;
  top: 50px;
}
</style>
